﻿ using System;
  using System.Collections.Generic;
  using System.ComponentModel;
  using System.Data;
  using System.Drawing;
  using System.Text;
  using System.Windows.Forms;
  
  namespace SimpleSerial
  {
      public partial class Form1 : Form
      {
          // Add this variable

          string RxString;
          byte[] buff = new byte[10];
          byte[] buff2 = new byte[98152];
          Int64 offset = 0;
          
          public Form1()
          {
              InitializeComponent();
          }
  
          private void buttonStart_Click(object sender, EventArgs e)
          {
              serialPort1.PortName = "COM7";
              serialPort1.BaudRate = 57600;
  
              serialPort1.Open();
              if (serialPort1.IsOpen)
              {
                  buttonStart.Enabled = false;
                  buttonStop.Enabled = true;
                  textBox1.ReadOnly = false;
              }
          }
  
          private void buttonStop_Click(object sender, EventArgs e)
          {
              if (serialPort1.IsOpen)
              {
                  serialPort1.Close();
                  buttonStart.Enabled = true;
                  buttonStop.Enabled = false;
                  textBox1.ReadOnly = false;
              }
  
          }
  
          private void Form1_FormClosing(object sender, FormClosingEventArgs e)
          {
              if (serialPort1.IsOpen) serialPort1.Close();
          }
  
          private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
          {
              // If the port is closed, don't try to send a character.

              if(!serialPort1.IsOpen) return;
  
              // If the port is Open, declare a char[] array with one element.
              char[] buff = new char[1];
              
              // Load element 0 with the key character.

              buff[0] = e.KeyChar;
  
              // Send the one character buffer.
              serialPort1.Write(buff, 0, 1);
  
              // Set the KeyPress event as handled so the character won't
              // display locally. If you want it to display, omit the next line.
              e.Handled = true;
          }

          private string ByteArrayToString(byte[] arr)
          {
              System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
              return enc.GetString(arr);
          }

          private void DisplayText(object sender, EventArgs e)
          {
              RxString = ByteArrayToString(buff);
              textBox1.AppendText(RxString);
          }

          private void CreateFile(byte[] file)
          {
              string path = @"C:\Users\ipa\Desktop\jpeg_compression2.txt";
              if (!System.IO.File.Exists(path))
              {
                  using (System.IO.FileStream fs = System.IO.File.Create(path))
                  {

                      fs.Write(buff2, 0, buff2.Length);
                      serialPort1.Close();
                  }
              }
          }


          private void serialPort1_DataReceived
            (object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
          {
              serialPort1.Read(buff, 0, 10);
              buff.CopyTo(buff2, offset);
              offset = offset + 10;
                    if (offset >= 98150)
                    {
                        CreateFile(buff2);
                    }
          }
      }
  }
  


